DatabaseMetaData
Date: 2016-03-08

com.mysql.jdbc

## Class DatabaseMetaData

- java.lang.Object
- - com.mysql.jdbc.DatabaseMetaData

- All Implemented Interfaces:
    java.sql.DatabaseMetaData, java.sql.Wrapper
  Direct Known Subclasses:
    DatabaseMetaDataUsingInfoSchema, JDBC4DatabaseMetaData

      public class DatabaseMetaData
      extends java.lang.Object
      implements java.sql.DatabaseMetaData

  JDBC Interface to Mysql functions

  This class provides information about the database as a whole.

  Many of the methods here return lists of information in ResultSets. You can use the normal ResultSet methods such as getString and getInt to retrieve the data from these ResultSets. If a given form of metadata is not available, these methods show throw a SQLException.

  Some of these methods take arguments that are String patterns. These methods all have names such as fooPattern. Within a pattern String "%" means match any substring of 0 or more characters and "_" means match any one character.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `DatabaseMetaData.ComparableWrapper<K extends java.lang.Object & java.lang.Comparable<? super K>,V>` Helper/wrapper class to provide means of sorting objects by using a sorting key.
    `protected class` | `DatabaseMetaData.IndexMetaDataKey` Helper class to provide means of comparing indexes by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.
    `protected class` | `DatabaseMetaData.IteratorWithCleanup<T>`
    `(package private) class` | `DatabaseMetaData.LocalAndReferencedColumns`
    `protected static class` | `DatabaseMetaData.ProcedureType` Enumeration for Procedure Types
    `protected class` | `DatabaseMetaData.ResultSetIterator`
    `protected class` | `DatabaseMetaData.SingleStringIterator`
    `protected class` | `DatabaseMetaData.TableMetaDataKey` Helper class to provide means of comparing tables by TABLE_TYPE, TABLE_CAT, TABLE_SCHEM and TABLE_NAME.
    `protected static class` | `DatabaseMetaData.TableType` Enumeration for Table Types
    `(package private) class` | `DatabaseMetaData.TypeDescriptor` Parses and represents common data type information used by various column/parameter methods.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected MySQLConnection` | `conn` The connection to the database
    `protected java.lang.String` | `database` The 'current' database name being used
    `protected static int` | `MAX_IDENTIFIER_LENGTH`
    `protected java.lang.String` | `quotedId` What character to use when quoting identifiers
    `protected static byte[]` | `SYSTEM_TABLE_AS_BYTES`
    `protected static byte[]` | `TABLE_AS_BYTES`
    `protected static byte[]` | `VIEW_AS_BYTES`

    - ### Fields inherited from interface java.sql.DatabaseMetaData

      `attributeNoNulls, attributeNullable, attributeNullableUnknown, bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, functionColumnIn, functionColumnInOut, functionColumnOut, functionColumnResult, functionColumnUnknown, functionNoNulls, functionNoTable, functionNullable, functionNullableUnknown, functionResultUnknown, functionReturn, functionReturnsTable, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, sqlStateSQL, sqlStateSQL99, sqlStateXOpen, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `DatabaseMetaData(MySQLConnection connToSet, java.lang.String databaseToSet)` Creates a new DatabaseMetaData object.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `allProceduresAreCallable()` Can all the procedures returned by getProcedures be called by the current user?
    `boolean` | `allTablesAreSelectable()` Can all the tables returned by getTable be SELECTed by the current user?
    `(package private) static java.sql.ResultSet` | `buildResultSet(Field[] fields, java.util.ArrayList<ResultSetRow> rows, MySQLConnection c)`
    `protected void` | `convertToJdbcFunctionList(java.lang.String catalog, java.sql.ResultSet proceduresRs, boolean needsClientFiltering, java.lang.String db, java.util.List<DatabaseMetaData.ComparableWrapper<java.lang.String,ResultSetRow>> procedureRows, int nameIndex, Field[] fields)`
    `protected void` | `convertToJdbcProcedureList(boolean fromSelect, java.lang.String catalog, java.sql.ResultSet proceduresRs, boolean needsClientFiltering, java.lang.String db, java.util.List<DatabaseMetaData.ComparableWrapper<java.lang.String,ResultSetRow>> procedureRows, int nameIndex)`
    `protected Field[]` | `createColumnsFields()`
    `protected Field[]` | `createFieldMetadataForGetProcedures()`
    `protected Field[]` | `createFkMetadataFields()`
    `protected Field[]` | `createFunctionColumnsFields()`
    `protected Field[]` | `createIndexInfoFields()`
    `protected Field[]` | `createProcedureColumnsFields()`
    `protected Field[]` | `createTablesFields()`
    `boolean` | `dataDefinitionCausesTransactionCommit()` Does a data definition statement within a transaction force the transaction to commit?
    `boolean` | `dataDefinitionIgnoredInTransactions()` Is a data definition statement within a transaction ignored?
    `boolean` | `deletesAreDetected(int type)` JDBC 2.0 Determine whether or not a visible row delete can be detected by calling ResultSet.rowDeleted().
    `boolean` | `doesMaxRowSizeIncludeBlobs()` Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
    `java.util.List<ResultSetRow>` | `extractForeignKeyForTable(java.util.ArrayList<ResultSetRow> rows, java.sql.ResultSet rs, java.lang.String catalog)` Extracts foreign key info for one table.
    `java.sql.ResultSet` | `extractForeignKeyFromCreateTable(java.lang.String catalog, java.lang.String tableName)` Creates a result set similar enough to 'SHOW TABLE STATUS' to allow the same code to work on extracting the foreign key data
    `boolean` | `generatedKeyAlwaysReturned()`
    `java.sql.ResultSet` | `getAttributes(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2, java.lang.String arg3)`
    `java.sql.ResultSet` | `getBestRowIdentifier(java.lang.String catalog, java.lang.String schema, java.lang.String table, int scope, boolean nullable)` Get a description of a table's optimal set of columns that uniquely identifies a row.
    `protected DatabaseMetaData.IteratorWithCleanup<java.lang.String>` | `getCatalogIterator(java.lang.String catalogSpec)`
    `java.sql.ResultSet` | `getCatalogs()` Get the catalog names available in this database.
    `java.lang.String` | `getCatalogSeparator()` What's the separator between catalog and table name?
    `java.lang.String` | `getCatalogTerm()` What's the database vendor's preferred term for "catalog"?
    `java.sql.ResultSet` | `getClientInfoProperties()` Retrieves a list of the client info properties that the driver supports.
    `java.sql.ResultSet` | `getColumnPrivileges(java.lang.String catalog, java.lang.String schema, java.lang.String table, java.lang.String columnNamePattern)` Get a description of the access rights for a table's columns.
    `java.sql.ResultSet` | `getColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String columnNamePattern)` Get a description of table columns available in a catalog.
    `protected int` | `getColumnType(boolean isOutParam, boolean isInParam, boolean isReturnParam, boolean forGetFunctionColumns)` Determines the COLUMN_TYPE information based on parameter type (IN, OUT or INOUT) or function return parameter.
    `java.sql.Connection` | `getConnection()` JDBC 2.0 Return the connection that produced this metadata object.
    `java.sql.ResultSet` | `getCrossReference(java.lang.String primaryCatalog, java.lang.String primarySchema, java.lang.String primaryTable, java.lang.String foreignCatalog, java.lang.String foreignSchema, java.lang.String foreignTable)` Get a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.)
    `int` | `getDatabaseMajorVersion()`
    `int` | `getDatabaseMinorVersion()`
    `java.lang.String` | `getDatabaseProductName()` What's the name of this database product?
    `java.lang.String` | `getDatabaseProductVersion()` What's the version of this database product?
    `int` | `getDefaultTransactionIsolation()` What's the database's default transaction isolation level?
    `int` | `getDriverMajorVersion()` What's this JDBC driver's major version number?
    `int` | `getDriverMinorVersion()` What's this JDBC driver's minor version number?
    `java.lang.String` | `getDriverName()` What's the name of this JDBC driver?
    `java.lang.String` | `getDriverVersion()` What's the version of this JDBC driver?
    `protected ExceptionInterceptor` | `getExceptionInterceptor()`
    `java.sql.ResultSet` | `getExportedKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Get a description of a foreign key columns that reference a table's primary key columns (the foreign keys exported by a table).
    `protected void` | `getExportKeyResults(java.lang.String catalog, java.lang.String exportingTable, java.lang.String keysComment, java.util.List<ResultSetRow> tuples, java.lang.String fkTableName)` Adds to the tuples list the exported keys of exportingTable based on the keysComment from the 'show table status' sql command.
    `java.lang.String` | `getExtraNameCharacters()` Get all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, 0-9 and _).
    `protected int[]` | `getForeignKeyActions(java.lang.String commentString)` Returns the DELETE and UPDATE foreign key actions from the given 'SHOW TABLE STATUS' string, with the DELETE action being the first item in the array, and the UPDATE action being the second.
    `protected java.lang.String` | `getFullyQualifiedName(java.lang.String catalog, java.lang.String entity)` Builds and returns a fully qualified name, quoted if necessary, for the given catalog and database entity.
    `java.sql.ResultSet` | `getFunctionColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String functionNamePattern, java.lang.String columnNamePattern)` Retrieves a description of the given catalog's system or user function parameters and return type.
    `java.sql.ResultSet` | `getFunctions(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String functionNamePattern)` Retrieves a description of the system and user functions available in the given catalog.
    `java.lang.String` | `getIdentifierQuoteString()` What's the string used to quote SQL identifiers?
    `java.sql.ResultSet` | `getImportedKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Get a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table).
    `protected void` | `getImportKeyResults(java.lang.String catalog, java.lang.String importingTable, java.lang.String keysComment, java.util.List<ResultSetRow> tuples)` Populates the tuples list with the imported keys of importingTable based on the keysComment from the 'show table status' sql command.
    `java.sql.ResultSet` | `getIndexInfo(java.lang.String catalog, java.lang.String schema, java.lang.String table, boolean unique, boolean approximate)` Get a description of a table's indices and statistics.
    `protected static DatabaseMetaData` | `getInstance(MySQLConnection connToSet, java.lang.String databaseToSet, boolean checkForInfoSchema)`
    `protected int` | `getJDBC4FunctionNoTableConstant()` Getter to JDBC4 DatabaseMetaData.functionNoTable constant.
    `int` | `getJDBCMajorVersion()`
    `int` | `getJDBCMinorVersion()`
    `int` | `getMaxBinaryLiteralLength()` How many hex characters can you have in an inline binary literal?
    `int` | `getMaxCatalogNameLength()` What's the maximum length of a catalog name?
    `int` | `getMaxCharLiteralLength()` What's the max length for a character literal?
    `int` | `getMaxColumnNameLength()` What's the limit on column name length?
    `int` | `getMaxColumnsInGroupBy()` What's the maximum number of columns in a "GROUP BY" clause?
    `int` | `getMaxColumnsInIndex()` What's the maximum number of columns allowed in an index?
    `int` | `getMaxColumnsInOrderBy()` What's the maximum number of columns in an "ORDER BY" clause?
    `int` | `getMaxColumnsInSelect()` What's the maximum number of columns in a "SELECT" list?
    `int` | `getMaxColumnsInTable()` What's maximum number of columns in a table?
    `int` | `getMaxConnections()` How many active connections can we have at a time to this database?
    `int` | `getMaxCursorNameLength()` What's the maximum cursor name length?
    `int` | `getMaxIndexLength()` What's the maximum length of an index (in bytes)?
    `int` | `getMaxProcedureNameLength()` What's the maximum length of a procedure name?
    `int` | `getMaxRowSize()` What's the maximum length of a single row?
    `int` | `getMaxSchemaNameLength()` What's the maximum length allowed for a schema name?
    `int` | `getMaxStatementLength()` What's the maximum length of a SQL statement?
    `int` | `getMaxStatements()` How many active statements can we have open at one time to this database?
    `int` | `getMaxTableNameLength()` What's the maximum length of a table name?
    `int` | `getMaxTablesInSelect()` What's the maximum number of tables in a SELECT?
    `int` | `getMaxUserNameLength()` What's the maximum length of a user name?
    `java.lang.String` | `getNumericFunctions()` Get a comma separated list of math functions.
    `java.sql.ResultSet` | `getPrimaryKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Get a description of a table's primary key columns.
    `java.sql.ResultSet` | `getProcedureColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern, java.lang.String columnNamePattern)` Get a description of a catalog's stored procedure parameters and result columns.
    `protected java.sql.ResultSet` | `getProcedureOrFunctionColumns(Field[] fields, java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureOrFunctionNamePattern, java.lang.String columnNamePattern, boolean returnProcedures, boolean returnFunctions)`
    `java.sql.ResultSet` | `getProcedures(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern)` Get a description of stored procedures available in a catalog.
    `protected java.sql.ResultSet` | `getProceduresAndOrFunctions(Field[] fields, java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern, boolean returnProcedures, boolean returnFunctions)`
    `java.lang.String` | `getProcedureTerm()` What's the database vendor's preferred term for "procedure"?
    `java.sql.ResultSet` | `getPseudoColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String columnNamePattern)` JDBC-4.1
    `int` | `getResultSetHoldability()`
    `java.sql.ResultSet` | `getSchemas()` Get the schema names available in this database.
    `java.sql.ResultSet` | `getSchemas(java.lang.String catalog, java.lang.String schemaPattern)`
    `java.lang.String` | `getSchemaTerm()` What's the database vendor's preferred term for "schema"?
    `java.lang.String` | `getSearchStringEscape()` This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.
    `java.lang.String` | `getSQLKeywords()` Get a comma separated list of all a database's SQL keywords that are NOT also SQL92/SQL2003 keywords.
    `int` | `getSQLStateType()`
    `java.lang.String` | `getStringFunctions()` Get a comma separated list of string functions.
    `java.sql.ResultSet` | `getSuperTables(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2)`
    `java.sql.ResultSet` | `getSuperTypes(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2)`
    `java.lang.String` | `getSystemFunctions()` Get a comma separated list of system functions.
    `protected java.lang.String` | `getTableNameWithCase(java.lang.String table)`
    `java.sql.ResultSet` | `getTablePrivileges(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern)` Get a description of the access rights for each table available in a catalog.
    `java.sql.ResultSet` | `getTables(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String[] types)` Get a description of tables available in a catalog.
    `java.sql.ResultSet` | `getTableTypes()` Get the table types available in this database.
    `java.lang.String` | `getTimeDateFunctions()` Get a comma separated list of time and date functions.
    `java.sql.ResultSet` | `getTypeInfo()` Get a description of all the standard SQL types supported by this database.
    `java.sql.ResultSet` | `getUDTs(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String typeNamePattern, int[] types)` JDBC 2.0 Get a description of the user-defined types defined in a particular schema.
    `java.lang.String` | `getURL()` What's the url for this database?
    `java.lang.String` | `getUserName()` What's our user name as known to the database?
    `java.sql.ResultSet` | `getVersionColumns(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Get a description of a table's columns that are automatically updated when any value in a row is updated.
    `boolean` | `insertsAreDetected(int type)` JDBC 2.0 Determine whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
    `boolean` | `isCatalogAtStart()` Does a catalog appear at the start of a qualified table name?
    `boolean` | `isReadOnly()` Is the database in read-only mode?
    `boolean` | `locatorsUpdateCopy()`
    `boolean` | `nullPlusNonNullIsNull()` Are concatenations between NULL and non-NULL values NULL?
    `boolean` | `nullsAreSortedAtEnd()` Are NULL values sorted at the end regardless of sort order?
    `boolean` | `nullsAreSortedAtStart()` Are NULL values sorted at the start regardless of sort order?
    `boolean` | `nullsAreSortedHigh()` Are NULL values sorted high?
    `boolean` | `nullsAreSortedLow()` Are NULL values sorted low?
    `boolean` | `othersDeletesAreVisible(int type)`
    `boolean` | `othersInsertsAreVisible(int type)`
    `boolean` | `othersUpdatesAreVisible(int type)` JDBC 2.0 Determine whether changes made by others are visible.
    `boolean` | `ownDeletesAreVisible(int type)`
    `boolean` | `ownInsertsAreVisible(int type)`
    `boolean` | `ownUpdatesAreVisible(int type)` JDBC 2.0 Determine whether a result set's own changes visible.
    `protected DatabaseMetaData.LocalAndReferencedColumns` | `parseTableStatusIntoLocalAndReferencedColumns(java.lang.String keysComment)`
    `protected java.sql.PreparedStatement` | `prepareMetaDataSafeStatement(java.lang.String sql)` Get a prepared statement to query information_schema tables.
    `boolean` | `providesQueryObjectGenerator()`
    `protected byte[]` | `s2b(java.lang.String s)` Converts the given string to bytes, using the connection's character encoding, or if not available, the JVM default encoding.
    `boolean` | `storesLowerCaseIdentifiers()` Does the database store mixed case unquoted SQL identifiers in lower case?
    `boolean` | `storesLowerCaseQuotedIdentifiers()` Does the database store mixed case quoted SQL identifiers in lower case?
    `boolean` | `storesMixedCaseIdentifiers()` Does the database store mixed case unquoted SQL identifiers in mixed case?
    `boolean` | `storesMixedCaseQuotedIdentifiers()` Does the database store mixed case quoted SQL identifiers in mixed case?
    `boolean` | `storesUpperCaseIdentifiers()` Does the database store mixed case unquoted SQL identifiers in upper case?
    `boolean` | `storesUpperCaseQuotedIdentifiers()` Does the database store mixed case quoted SQL identifiers in upper case?
    `boolean` | `supportsAlterTableWithAddColumn()` Is "ALTER TABLE" with add column supported?
    `boolean` | `supportsAlterTableWithDropColumn()` Is "ALTER TABLE" with drop column supported?
    `boolean` | `supportsANSI92EntryLevelSQL()` Is the ANSI92 entry level SQL grammar supported?
    `boolean` | `supportsANSI92FullSQL()` Is the ANSI92 full SQL grammar supported?
    `boolean` | `supportsANSI92IntermediateSQL()` Is the ANSI92 intermediate SQL grammar supported?
    `boolean` | `supportsBatchUpdates()` JDBC 2.0 Return true if the driver supports batch updates, else return false.
    `boolean` | `supportsCatalogsInDataManipulation()` Can a catalog name be used in a data manipulation statement?
    `boolean` | `supportsCatalogsInIndexDefinitions()` Can a catalog name be used in a index definition statement?
    `boolean` | `supportsCatalogsInPrivilegeDefinitions()` Can a catalog name be used in a privilege definition statement?
    `boolean` | `supportsCatalogsInProcedureCalls()` Can a catalog name be used in a procedure call statement?
    `boolean` | `supportsCatalogsInTableDefinitions()` Can a catalog name be used in a table definition statement?
    `boolean` | `supportsColumnAliasing()` Is column aliasing supported?
    `boolean` | `supportsConvert()` Is the CONVERT function between SQL types supported?
    `boolean` | `supportsConvert(int fromType, int toType)` Is CONVERT between the given SQL types supported?
    `boolean` | `supportsCoreSQLGrammar()` Is the ODBC Core SQL grammar supported?
    `boolean` | `supportsCorrelatedSubqueries()` Are correlated subqueries supported?
    `boolean` | `supportsDataDefinitionAndDataManipulationTransactions()` Are both data definition and data manipulation statements within a transaction supported?
    `boolean` | `supportsDataManipulationTransactionsOnly()` Are only data manipulation statements within a transaction supported?
    `boolean` | `supportsDifferentTableCorrelationNames()` If table correlation names are supported, are they restricted to be different from the names of the tables?
    `boolean` | `supportsExpressionsInOrderBy()` Are expressions in "ORDER BY" lists supported?
    `boolean` | `supportsExtendedSQLGrammar()` Is the ODBC Extended SQL grammar supported?
    `boolean` | `supportsFullOuterJoins()` Are full nested outer joins supported?
    `boolean` | `supportsGetGeneratedKeys()` JDBC 3.0
    `boolean` | `supportsGroupBy()` Is some form of "GROUP BY" clause supported?
    `boolean` | `supportsGroupByBeyondSelect()` Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
    `boolean` | `supportsGroupByUnrelated()` Can a "GROUP BY" clause use columns not in the SELECT?
    `boolean` | `supportsIntegrityEnhancementFacility()` Is the SQL Integrity Enhancement Facility supported?
    `boolean` | `supportsLikeEscapeClause()` Is the escape character in "LIKE" clauses supported?
    `boolean` | `supportsLimitedOuterJoins()` Is there limited support for outer joins?
    `boolean` | `supportsMinimumSQLGrammar()` Is the ODBC Minimum SQL grammar supported?
    `boolean` | `supportsMixedCaseIdentifiers()` Does the database support mixed case unquoted SQL identifiers?
    `boolean` | `supportsMixedCaseQuotedIdentifiers()` Does the database support mixed case quoted SQL identifiers?
    `boolean` | `supportsMultipleOpenResults()`
    `boolean` | `supportsMultipleResultSets()` Are multiple ResultSets from a single execute supported?
    `boolean` | `supportsMultipleTransactions()` Can we have multiple transactions open at once (on different connections)?
    `boolean` | `supportsNamedParameters()`
    `boolean` | `supportsNonNullableColumns()` Can columns be defined as non-nullable?
    `boolean` | `supportsOpenCursorsAcrossCommit()` Can cursors remain open across commits?
    `boolean` | `supportsOpenCursorsAcrossRollback()` Can cursors remain open across rollbacks?
    `boolean` | `supportsOpenStatementsAcrossCommit()` Can statements remain open across commits?
    `boolean` | `supportsOpenStatementsAcrossRollback()` Can statements remain open across rollbacks?
    `boolean` | `supportsOrderByUnrelated()` Can an "ORDER BY" clause use columns not in the SELECT?
    `boolean` | `supportsOuterJoins()` Is some form of outer join supported?
    `boolean` | `supportsPositionedDelete()` Is positioned DELETE supported?
    `boolean` | `supportsPositionedUpdate()` Is positioned UPDATE supported?
    `boolean` | `supportsResultSetConcurrency(int type, int concurrency)` JDBC 2.0 Does the database support the concurrency type in combination with the given result set type?
    `boolean` | `supportsResultSetHoldability(int holdability)`
    `boolean` | `supportsResultSetType(int type)` JDBC 2.0 Does the database support the given result set type?
    `boolean` | `supportsSavepoints()`
    `boolean` | `supportsSchemasInDataManipulation()` Can a schema name be used in a data manipulation statement?
    `boolean` | `supportsSchemasInIndexDefinitions()` Can a schema name be used in an index definition statement?
    `boolean` | `supportsSchemasInPrivilegeDefinitions()` Can a schema name be used in a privilege definition statement?
    `boolean` | `supportsSchemasInProcedureCalls()` Can a schema name be used in a procedure call statement?
    `boolean` | `supportsSchemasInTableDefinitions()` Can a schema name be used in a table definition statement?
    `boolean` | `supportsSelectForUpdate()` Is SELECT for UPDATE supported?
    `boolean` | `supportsStatementPooling()`
    `boolean` | `supportsStoredFunctionsUsingCallSyntax()`
    `boolean` | `supportsStoredProcedures()` Are stored procedure calls using the stored procedure escape syntax supported?
    `boolean` | `supportsSubqueriesInComparisons()` Are subqueries in comparison expressions supported?
    `boolean` | `supportsSubqueriesInExists()` Are subqueries in exists expressions supported?
    `boolean` | `supportsSubqueriesInIns()` Are subqueries in "in" statements supported?
    `boolean` | `supportsSubqueriesInQuantifieds()` Are subqueries in quantified expressions supported?
    `boolean` | `supportsTableCorrelationNames()` Are table correlation names supported?
    `boolean` | `supportsTransactionIsolationLevel(int level)` Does the database support the given transaction isolation level?
    `boolean` | `supportsTransactions()` Are transactions supported?
    `boolean` | `supportsUnion()` Is SQL UNION supported?
    `boolean` | `supportsUnionAll()` Is SQL UNION ALL supported?
    `boolean` | `updatesAreDetected(int type)` JDBC 2.0 Determine whether or not a visible row update can be detected by calling ResultSet.rowUpdated().
    `boolean` | `usesLocalFilePerTable()` Does the database use a file for each table?
    `boolean` | `usesLocalFiles()` Does the database store tables in a local file?

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.sql.DatabaseMetaData

      `autoCommitFailureClosesAllResultSets, getRowIdLifetime`

    - ### Methods inherited from interface java.sql.Wrapper

      `isWrapperFor, unwrap`

- - ### Field Detail

    - #### MAX_IDENTIFIER_LENGTH

          protected static final int MAX_IDENTIFIER_LENGTH

      See Also:
        Constant Field Values

    - #### TABLE_AS_BYTES

          protected static final byte[] TABLE_AS_BYTES

    - #### SYSTEM_TABLE_AS_BYTES

          protected static final byte[] SYSTEM_TABLE_AS_BYTES

    - #### VIEW_AS_BYTES

          protected static final byte[] VIEW_AS_BYTES

    - #### conn

          protected MySQLConnection conn

      The connection to the database

    - #### database

          protected java.lang.String database

      The 'current' database name being used

    - #### quotedId

          protected final java.lang.String quotedId

      What character to use when quoting identifiers

  - ### Constructor Detail

    - #### DatabaseMetaData

          protected DatabaseMetaData(MySQLConnection connToSet,
                          java.lang.String databaseToSet)

      Creates a new DatabaseMetaData object.
      Parameters:
        `connToSet` -
        `databaseToSet` -

  - ### Method Detail

    - #### getInstance

          protected static DatabaseMetaData getInstance(MySQLConnection connToSet,
                                     java.lang.String databaseToSet,
                                     boolean checkForInfoSchema)
                                                 throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### allProceduresAreCallable

          public boolean allProceduresAreCallable()
                                           throws java.sql.SQLException

      Can all the procedures returned by getProcedures be called by the current user?
      Specified by:
        `allProceduresAreCallable` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### allTablesAreSelectable

          public boolean allTablesAreSelectable()
                                         throws java.sql.SQLException

      Can all the tables returned by getTable be SELECTed by the current user?
      Specified by:
        `allTablesAreSelectable` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### buildResultSet

          static java.sql.ResultSet buildResultSet(Field[] fields,
                                          java.util.ArrayList<ResultSetRow> rows,
                                          MySQLConnection c)
                                            throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### convertToJdbcFunctionList

          protected void convertToJdbcFunctionList(java.lang.String catalog,
                                       java.sql.ResultSet proceduresRs,
                                       boolean needsClientFiltering,
                                       java.lang.String db,
                                       java.util.List<DatabaseMetaData.ComparableWrapper<java.lang.String,ResultSetRow>> procedureRows,
                                       int nameIndex,
                                       Field[] fields)
                                            throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### getFullyQualifiedName

          protected java.lang.String getFullyQualifiedName(java.lang.String catalog,
                                               java.lang.String entity)

      Builds and returns a fully qualified name, quoted if necessary, for the given catalog and database entity.

    - #### getJDBC4FunctionNoTableConstant

          protected int getJDBC4FunctionNoTableConstant()

      Getter to JDBC4 DatabaseMetaData.functionNoTable constant. This method must be overridden by JDBC4 subclasses. This implementation should never be called.
      Returns:
        0

    - #### convertToJdbcProcedureList

          protected void convertToJdbcProcedureList(boolean fromSelect,
                                        java.lang.String catalog,
                                        java.sql.ResultSet proceduresRs,
                                        boolean needsClientFiltering,
                                        java.lang.String db,
                                        java.util.List<DatabaseMetaData.ComparableWrapper<java.lang.String,ResultSetRow>> procedureRows,
                                        int nameIndex)
                                             throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### getColumnType

          protected int getColumnType(boolean isOutParam,
                          boolean isInParam,
                          boolean isReturnParam,
                          boolean forGetFunctionColumns)

      Determines the COLUMN_TYPE information based on parameter type (IN, OUT or INOUT) or function return parameter.
      Parameters:
        `isOutParam` - Indicates whether it's an output parameter.
        `isInParam` - Indicates whether it's an input parameter.
        `isReturnParam` - Indicates whether it's a function return parameter.
        `forGetFunctionColumns` - Indicates whether the column belong to a function. This argument is required for JDBC4, in which case this method must be overridden to provide the correct functionality.
      Returns:
        The corresponding COLUMN_TYPE as in java.sql.getProcedureColumns API.

    - #### getExceptionInterceptor

          protected ExceptionInterceptor getExceptionInterceptor()

    - #### dataDefinitionCausesTransactionCommit

          public boolean dataDefinitionCausesTransactionCommit()
                                                        throws java.sql.SQLException

      Does a data definition statement within a transaction force the transaction to commit?
      Specified by:
        `dataDefinitionCausesTransactionCommit` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### dataDefinitionIgnoredInTransactions

          public boolean dataDefinitionIgnoredInTransactions()
                                                      throws java.sql.SQLException

      Is a data definition statement within a transaction ignored?
      Specified by:
        `dataDefinitionIgnoredInTransactions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### deletesAreDetected

          public boolean deletesAreDetected(int type)
                                     throws java.sql.SQLException

      JDBC 2.0 Determine whether or not a visible row delete can be detected by calling ResultSet.rowDeleted(). If deletesAreDetected() returns false, then deleted rows are removed from the result set.
      Specified by:
        `deletesAreDetected` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` - set type, i.e. ResultSet.TYPE_XXX
      Returns:
        true if changes are detected by the resultset type
      Throws:
        `java.sql.SQLException` - if a database-access error occurs.

    - #### doesMaxRowSizeIncludeBlobs

          public boolean doesMaxRowSizeIncludeBlobs()
                                             throws java.sql.SQLException

      Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
      Specified by:
        `doesMaxRowSizeIncludeBlobs` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### extractForeignKeyForTable

          public java.util.List<ResultSetRow> extractForeignKeyForTable(java.util.ArrayList<ResultSetRow> rows,
                                                               java.sql.ResultSet rs,
                                                               java.lang.String catalog)
                                                                 throws java.sql.SQLException

      Extracts foreign key info for one table.
      Parameters:
        `rows` - the list of rows to add to
        `rs` - the result set from 'SHOW CREATE TABLE'
        `catalog` - the database name
      Returns:
        the list of rows with new rows added
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### extractForeignKeyFromCreateTable

          public java.sql.ResultSet extractForeignKeyFromCreateTable(java.lang.String catalog,
                                                            java.lang.String tableName)
                                                              throws java.sql.SQLException

      Creates a result set similar enough to 'SHOW TABLE STATUS' to allow the same code to work on extracting the foreign key data
      Parameters:
        `connToUse` - the database connection to use
        `metadata` - the DatabaseMetaData instance calling this method
        `catalog` - the database name to extract foreign key info for
        `tableName` - the table to extract foreign key info for
      Returns:
        A result set that has the structure of 'show table status'
      Throws:
        `java.sql.SQLException` - if a database access error occurs.

    - #### getAttributes

          public java.sql.ResultSet getAttributes(java.lang.String arg0,
                                         java.lang.String arg1,
                                         java.lang.String arg2,
                                         java.lang.String arg3)
                                           throws java.sql.SQLException

      Specified by:
        `getAttributes` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getAttributes(String, String, String, String)`

    - #### getBestRowIdentifier

          public java.sql.ResultSet getBestRowIdentifier(java.lang.String catalog,
                                                java.lang.String schema,
                                                java.lang.String table,
                                                int scope,
                                                boolean nullable)
                                                  throws java.sql.SQLException

      Get a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

      Each column description has the following columns:

      1. SCOPE short => actual scope of result
         - bestRowTemporary - very temporary, while using row
         - bestRowTransaction - valid for remainder of current transaction
         - bestRowSession - valid for remainder of current session
      2. COLUMN_NAME String => column name
      3. DATA_TYPE short => SQL data type from java.sql.Types
      4. TYPE_NAME String => Data source dependent type name
      5. COLUMN_SIZE int => precision
      6. BUFFER_LENGTH int => not used
      7. DECIMAL_DIGITS short => scale
      8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
         - bestRowUnknown - may or may not be pseudo column
         - bestRowNotPseudo - is NOT a pseudo column
         - bestRowPseudo - is a pseudo column
      Specified by:
        `getBestRowIdentifier` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schema` - a schema name; "" retrieves those without a schema
        `table` - a table name
        `scope` - the scope of interest; use same values as SCOPE
        `nullable` - include columns that are nullable?
      Returns:
        ResultSet each row is a column description
      Throws:
        `java.sql.SQLException`

    - #### getCatalogIterator

          protected DatabaseMetaData.IteratorWithCleanup<java.lang.String> getCatalogIterator(java.lang.String catalogSpec)
                                                                                       throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### getCatalogs

          public java.sql.ResultSet getCatalogs()
                                         throws java.sql.SQLException

      Get the catalog names available in this database. The results are ordered by catalog name.

      The catalog column is:

      1. TABLE_CAT String => catalog name
      Specified by:
        `getCatalogs` in interface `java.sql.DatabaseMetaData`
      Returns:
        ResultSet each row has a single String column that is a catalog name
      Throws:
        `java.sql.SQLException`

    - #### getCatalogSeparator

          public java.lang.String getCatalogSeparator()
                                               throws java.sql.SQLException

      What's the separator between catalog and table name?
      Specified by:
        `getCatalogSeparator` in interface `java.sql.DatabaseMetaData`
      Returns:
        the separator string
      Throws:
        `java.sql.SQLException`

    - #### getCatalogTerm

          public java.lang.String getCatalogTerm()
                                          throws java.sql.SQLException

      What's the database vendor's preferred term for "catalog"?
      Specified by:
        `getCatalogTerm` in interface `java.sql.DatabaseMetaData`
      Returns:
        the vendor term
      Throws:
        `java.sql.SQLException`

    - #### getColumnPrivileges

          public java.sql.ResultSet getColumnPrivileges(java.lang.String catalog,
                                               java.lang.String schema,
                                               java.lang.String table,
                                               java.lang.String columnNamePattern)
                                                 throws java.sql.SQLException

      Get a description of the access rights for a table's columns.

      Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

      Each privilige description has the following columns:

      1. TABLE_CAT String => table catalog (may be null)
      2. TABLE_SCHEM String => table schema (may be null)
      3. TABLE_NAME String => table name
      4. COLUMN_NAME String => column name
      5. GRANTOR => grantor of access (may be null)
      6. GRANTEE String => grantee of access
      7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
      8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown
      Specified by:
        `getColumnPrivileges` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schema` - a schema name; "" retrieves those without a schema
        `table` - a table name
        `columnNamePattern` - a column name pattern
      Returns:
        ResultSet each row is a column privilege description
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `getSearchStringEscape()`

    - #### getColumns

          public java.sql.ResultSet getColumns(java.lang.String catalog,
                                      java.lang.String schemaPattern,
                                      java.lang.String tableNamePattern,
                                      java.lang.String columnNamePattern)
                                        throws java.sql.SQLException

      Get a description of table columns available in a catalog.

      Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME and ORDINAL_POSITION.

      Each column description has the following columns:

      1. TABLE_CAT String => table catalog (may be null)
      2. TABLE_SCHEM String => table schema (may be null)
      3. TABLE_NAME String => table name
      4. COLUMN_NAME String => column name
      5. DATA_TYPE short => SQL type from java.sql.Types
      6. TYPE_NAME String => Data source dependent type name
      7. COLUMN_SIZE int => column size. For char or date types this is the maximum number of characters, for numeric or decimal types this is precision.
      8. BUFFER_LENGTH is not used.
      9. DECIMAL_DIGITS int => the number of fractional digits
      10. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
      11. NULLABLE int => is NULL allowed?
          - columnNoNulls - might not allow NULL values
          - columnNullable - definitely allows NULL values
          - columnNullableUnknown - nullability unknown
      12. REMARKS String => comment describing column (may be null)
      13. COLUMN_DEF String => default value (may be null)
      14. SQL_DATA_TYPE int => unused
      15. SQL_DATETIME_SUB int => unused
      16. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
      17. ORDINAL_POSITION int => index of column in table (starting at 1)
      18. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means nobody knows.
      Specified by:
        `getColumns` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schemaPattern` - a schema name pattern; "" retrieves those without a schema
        `tableNamePattern` - a table name pattern
        `columnNamePattern` - a column name pattern
      Returns:
        ResultSet each row is a column description
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `getSearchStringEscape()`

    - #### createColumnsFields

          protected Field[] createColumnsFields()

    - #### getConnection

          public java.sql.Connection getConnection()
                                            throws java.sql.SQLException

      JDBC 2.0 Return the connection that produced this metadata object.
      Specified by:
        `getConnection` in interface `java.sql.DatabaseMetaData`
      Returns:
        the connection that produced this metadata object.
      Throws:
        `java.sql.SQLException` - if a database error occurs

    - #### getCrossReference

          public java.sql.ResultSet getCrossReference(java.lang.String primaryCatalog,
                                             java.lang.String primarySchema,
                                             java.lang.String primaryTable,
                                             java.lang.String foreignCatalog,
                                             java.lang.String foreignSchema,
                                             java.lang.String foreignTable)
                                               throws java.sql.SQLException

      Get a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

      Each foreign key column description has the following columns:

      1. PKTABLE_CAT String => primary key table catalog (may be null)
      2. PKTABLE_SCHEM String => primary key table schema (may be null)
      3. PKTABLE_NAME String => primary key table name
      4. PKCOLUMN_NAME String => primary key column name
      5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
      6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
      7. FKTABLE_NAME String => foreign key table name being exported
      8. FKCOLUMN_NAME String => foreign key column name being exported
      9. KEY_SEQ short => sequence number within foreign key
      10. UPDATE_RULE short => What happens to foreign key when primary is updated:
          - importedKeyCascade - change imported key to agree with primary key update
          - importedKeyRestrict - do not allow update of primary key if it has been imported
          - importedKeySetNull - change imported key to NULL if its primary key has been updated
      11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
          - importedKeyCascade - delete rows that import a deleted key
          - importedKeyRestrict - do not allow delete of primary key if it has been imported
          - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      12. FK_NAME String => foreign key identifier (may be null)
      13. PK_NAME String => primary key identifier (may be null)
      Specified by:
        `getCrossReference` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `primaryCatalog` - a catalog name; "" retrieves those without a catalog
        `primarySchema` - a schema name pattern; "" retrieves those without a schema
        `primaryTable` - a table name
        `foreignCatalog` - a catalog name; "" retrieves those without a catalog
        `foreignSchema` - a schema name pattern; "" retrieves those without a schema
        `foreignTable` - a table name
      Returns:
        ResultSet each row is a foreign key column description
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### createFkMetadataFields

          protected Field[] createFkMetadataFields()

    - #### getDatabaseMajorVersion

          public int getDatabaseMajorVersion()
                                      throws java.sql.SQLException

      Specified by:
        `getDatabaseMajorVersion` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getDatabaseMajorVersion()`

    - #### getDatabaseMinorVersion

          public int getDatabaseMinorVersion()
                                      throws java.sql.SQLException

      Specified by:
        `getDatabaseMinorVersion` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getDatabaseMinorVersion()`

    - #### getDatabaseProductName

          public java.lang.String getDatabaseProductName()
                                                  throws java.sql.SQLException

      What's the name of this database product?
      Specified by:
        `getDatabaseProductName` in interface `java.sql.DatabaseMetaData`
      Returns:
        database product name
      Throws:
        `java.sql.SQLException`

    - #### getDatabaseProductVersion

          public java.lang.String getDatabaseProductVersion()
                                                     throws java.sql.SQLException

      What's the version of this database product?
      Specified by:
        `getDatabaseProductVersion` in interface `java.sql.DatabaseMetaData`
      Returns:
        database version
      Throws:
        `java.sql.SQLException`

    - #### getDefaultTransactionIsolation

          public int getDefaultTransactionIsolation()
                                             throws java.sql.SQLException

      What's the database's default transaction isolation level? The values are defined in java.sql.Connection.
      Specified by:
        `getDefaultTransactionIsolation` in interface `java.sql.DatabaseMetaData`
      Returns:
        the default isolation level
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `Connection`

    - #### getDriverMajorVersion

          public int getDriverMajorVersion()

      What's this JDBC driver's major version number?
      Specified by:
        `getDriverMajorVersion` in interface `java.sql.DatabaseMetaData`
      Returns:
        JDBC driver major version

    - #### getDriverMinorVersion

          public int getDriverMinorVersion()

      What's this JDBC driver's minor version number?
      Specified by:
        `getDriverMinorVersion` in interface `java.sql.DatabaseMetaData`
      Returns:
        JDBC driver minor version number

    - #### getDriverName

          public java.lang.String getDriverName()
                                         throws java.sql.SQLException

      What's the name of this JDBC driver?
      Specified by:
        `getDriverName` in interface `java.sql.DatabaseMetaData`
      Returns:
        JDBC driver name
      Throws:
        `java.sql.SQLException`

    - #### getDriverVersion

          public java.lang.String getDriverVersion()
                                            throws java.sql.SQLException

      What's the version of this JDBC driver?
      Specified by:
        `getDriverVersion` in interface `java.sql.DatabaseMetaData`
      Returns:
        JDBC driver version
      Throws:
        `java.sql.SQLException`

    - #### getExportedKeys

          public java.sql.ResultSet getExportedKeys(java.lang.String catalog,
                                           java.lang.String schema,
                                           java.lang.String table)
                                             throws java.sql.SQLException

      Get a description of a foreign key columns that reference a table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

      Each foreign key column description has the following columns:

      1. PKTABLE_CAT String => primary key table catalog (may be null)
      2. PKTABLE_SCHEM String => primary key table schema (may be null)
      3. PKTABLE_NAME String => primary key table name
      4. PKCOLUMN_NAME String => primary key column name
      5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
      6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
      7. FKTABLE_NAME String => foreign key table name being exported
      8. FKCOLUMN_NAME String => foreign key column name being exported
      9. KEY_SEQ short => sequence number within foreign key
      10. UPDATE_RULE short => What happens to foreign key when primary is updated:
          - importedKeyCascade - change imported key to agree with primary key update
          - importedKeyRestrict - do not allow update of primary key if it has been imported
          - importedKeySetNull - change imported key to NULL if its primary key has been updated
      11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
          - importedKeyCascade - delete rows that import a deleted key
          - importedKeyRestrict - do not allow delete of primary key if it has been imported
          - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      12. FK_NAME String => foreign key identifier (may be null)
      13. PK_NAME String => primary key identifier (may be null)
      Specified by:
        `getExportedKeys` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schema` - a schema name pattern; "" retrieves those without a schema
        `table` - a table name
      Returns:
        ResultSet each row is a foreign key column description
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

    - #### getExportKeyResults

          protected void getExportKeyResults(java.lang.String catalog,
                                 java.lang.String exportingTable,
                                 java.lang.String keysComment,
                                 java.util.List<ResultSetRow> tuples,
                                 java.lang.String fkTableName)
                                      throws java.sql.SQLException

      Adds to the tuples list the exported keys of exportingTable based on the keysComment from the 'show table status' sql command. KeysComment is that part of the comment field that follows the "InnoDB free ...;" prefix.
      Parameters:
        `catalog` - the database to use
        `exportingTable` - the table keys are being exported from
        `keysComment` - the comment from 'show table status'
        `tuples` - the rows to add results to
        `fkTableName` - the foreign key table name
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getExtraNameCharacters

          public java.lang.String getExtraNameCharacters()
                                                  throws java.sql.SQLException

      Get all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, 0-9 and _).
      Specified by:
        `getExtraNameCharacters` in interface `java.sql.DatabaseMetaData`
      Returns:
        the string containing the extra characters
      Throws:
        `java.sql.SQLException`

    - #### getForeignKeyActions

          protected int[] getForeignKeyActions(java.lang.String commentString)

      Returns the DELETE and UPDATE foreign key actions from the given 'SHOW TABLE STATUS' string, with the DELETE action being the first item in the array, and the UPDATE action being the second.
      Parameters:
        `commentString` - the comment from 'SHOW TABLE STATUS'
      Returns:
        int[] [0] = delete action, [1] = update action

    - #### getIdentifierQuoteString

          public java.lang.String getIdentifierQuoteString()
                                                    throws java.sql.SQLException

      What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported. A JDBC compliant driver always uses a double quote character.
      Specified by:
        `getIdentifierQuoteString` in interface `java.sql.DatabaseMetaData`
      Returns:
        the quoting string
      Throws:
        `java.sql.SQLException`

    - #### getImportedKeys

          public java.sql.ResultSet getImportedKeys(java.lang.String catalog,
                                           java.lang.String schema,
                                           java.lang.String table)
                                             throws java.sql.SQLException

      Get a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

      Each primary key column description has the following columns:

      1. PKTABLE_CAT String => primary key table catalog being imported (may be null)
      2. PKTABLE_SCHEM String => primary key table schema being imported (may be null)
      3. PKTABLE_NAME String => primary key table name being imported
      4. PKCOLUMN_NAME String => primary key column name being imported
      5. FKTABLE_CAT String => foreign key table catalog (may be null)
      6. FKTABLE_SCHEM String => foreign key table schema (may be null)
      7. FKTABLE_NAME String => foreign key table name
      8. FKCOLUMN_NAME String => foreign key column name
      9. KEY_SEQ short => sequence number within foreign key
      10. UPDATE_RULE short => What happens to foreign key when primary is updated:
          - importedKeyCascade - change imported key to agree with primary key update
          - importedKeyRestrict - do not allow update of primary key if it has been imported
          - importedKeySetNull - change imported key to NULL if its primary key has been updated
      11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
          - importedKeyCascade - delete rows that import a deleted key
          - importedKeyRestrict - do not allow delete of primary key if it has been imported
          - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      12. FK_NAME String => foreign key name (may be null)
      13. PK_NAME String => primary key name (may be null)
      Specified by:
        `getImportedKeys` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schema` - a schema name pattern; "" retrieves those without a schema
        `table` - a table name
      Returns:
        ResultSet each row is a primary key column description
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`

    - #### getImportKeyResults

          protected void getImportKeyResults(java.lang.String catalog,
                                 java.lang.String importingTable,
                                 java.lang.String keysComment,
                                 java.util.List<ResultSetRow> tuples)
                                      throws java.sql.SQLException

      Populates the tuples list with the imported keys of importingTable based on the keysComment from the 'show table status' sql command. KeysComment is that part of the comment field that follows the "InnoDB free ...;" prefix.
      Parameters:
        `catalog` - the database to use
        `importingTable` - the table keys are being imported to
        `keysComment` - the comment from 'show table status'
        `tuples` - the rows to add results to
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getIndexInfo

          public java.sql.ResultSet getIndexInfo(java.lang.String catalog,
                                        java.lang.String schema,
                                        java.lang.String table,
                                        boolean unique,
                                        boolean approximate)
                                          throws java.sql.SQLException

      Get a description of a table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

      Each index column description has the following columns:

      1. TABLE_CAT String => table catalog (may be null)
      2. TABLE_SCHEM String => table schema (may be null)
      3. TABLE_NAME String => table name
      4. NON_UNIQUE boolean => Can index values be non-unique? false when TYPE is tableIndexStatistic
      5. INDEX_QUALIFIER String => index catalog (may be null); null when TYPE is tableIndexStatistic
      6. INDEX_NAME String => index name; null when TYPE is tableIndexStatistic
      7. TYPE short => index type:
         - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
         - tableIndexClustered - this is a clustered index
         - tableIndexHashed - this is a hashed index
         - tableIndexOther - this is some other style of index
      8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
      9. COLUMN_NAME String => column name; null when TYPE is tableIndexStatistic
      10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be null if sort sequence is not supported; null when TYPE is tableIndexStatistic
      11. CARDINALITY int => When TYPE is tableIndexStatisic then this is the number of rows in the table; otherwise it is the number of unique values in the index.
      12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
      13. FILTER_CONDITION String => Filter condition, if any. (may be null)
      Specified by:
        `getIndexInfo` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schema` - a schema name pattern; "" retrieves those without a schema
        `table` - a table name
        `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
        `approximate` - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate
      Returns:
        ResultSet each row is an index column description
      Throws:
        `java.sql.SQLException`

    - #### createIndexInfoFields

          protected Field[] createIndexInfoFields()

    - #### getJDBCMajorVersion

          public int getJDBCMajorVersion()
                                  throws java.sql.SQLException

      Specified by:
        `getJDBCMajorVersion` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getJDBCMajorVersion()`

    - #### getJDBCMinorVersion

          public int getJDBCMinorVersion()
                                  throws java.sql.SQLException

      Specified by:
        `getJDBCMinorVersion` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getJDBCMinorVersion()`

    - #### getMaxBinaryLiteralLength

          public int getMaxBinaryLiteralLength()
                                        throws java.sql.SQLException

      How many hex characters can you have in an inline binary literal?
      Specified by:
        `getMaxBinaryLiteralLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max literal length
      Throws:
        `java.sql.SQLException`

    - #### getMaxCatalogNameLength

          public int getMaxCatalogNameLength()
                                      throws java.sql.SQLException

      What's the maximum length of a catalog name?
      Specified by:
        `getMaxCatalogNameLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max name length in bytes
      Throws:
        `java.sql.SQLException`

    - #### getMaxCharLiteralLength

          public int getMaxCharLiteralLength()
                                      throws java.sql.SQLException

      What's the max length for a character literal?
      Specified by:
        `getMaxCharLiteralLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max literal length
      Throws:
        `java.sql.SQLException`

    - #### getMaxColumnNameLength

          public int getMaxColumnNameLength()
                                     throws java.sql.SQLException

      What's the limit on column name length?
      Specified by:
        `getMaxColumnNameLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max literal length
      Throws:
        `java.sql.SQLException`

    - #### getMaxColumnsInGroupBy

          public int getMaxColumnsInGroupBy()
                                     throws java.sql.SQLException

      What's the maximum number of columns in a "GROUP BY" clause?
      Specified by:
        `getMaxColumnsInGroupBy` in interface `java.sql.DatabaseMetaData`
      Returns:
        max number of columns
      Throws:
        `java.sql.SQLException`

    - #### getMaxColumnsInIndex

          public int getMaxColumnsInIndex()
                                   throws java.sql.SQLException

      What's the maximum number of columns allowed in an index?
      Specified by:
        `getMaxColumnsInIndex` in interface `java.sql.DatabaseMetaData`
      Returns:
        max columns
      Throws:
        `java.sql.SQLException`

    - #### getMaxColumnsInOrderBy

          public int getMaxColumnsInOrderBy()
                                     throws java.sql.SQLException

      What's the maximum number of columns in an "ORDER BY" clause?
      Specified by:
        `getMaxColumnsInOrderBy` in interface `java.sql.DatabaseMetaData`
      Returns:
        max columns
      Throws:
        `java.sql.SQLException`

    - #### getMaxColumnsInSelect

          public int getMaxColumnsInSelect()
                                    throws java.sql.SQLException

      What's the maximum number of columns in a "SELECT" list?
      Specified by:
        `getMaxColumnsInSelect` in interface `java.sql.DatabaseMetaData`
      Returns:
        max columns
      Throws:
        `java.sql.SQLException`

    - #### getMaxColumnsInTable

          public int getMaxColumnsInTable()
                                   throws java.sql.SQLException

      What's maximum number of columns in a table?
      Specified by:
        `getMaxColumnsInTable` in interface `java.sql.DatabaseMetaData`
      Returns:
        max columns
      Throws:
        `java.sql.SQLException`

    - #### getMaxConnections

          public int getMaxConnections()
                                throws java.sql.SQLException

      How many active connections can we have at a time to this database?
      Specified by:
        `getMaxConnections` in interface `java.sql.DatabaseMetaData`
      Returns:
        max connections
      Throws:
        `java.sql.SQLException`

    - #### getMaxCursorNameLength

          public int getMaxCursorNameLength()
                                     throws java.sql.SQLException

      What's the maximum cursor name length?
      Specified by:
        `getMaxCursorNameLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max cursor name length in bytes
      Throws:
        `java.sql.SQLException`

    - #### getMaxIndexLength

          public int getMaxIndexLength()
                                throws java.sql.SQLException

      What's the maximum length of an index (in bytes)?
      Specified by:
        `getMaxIndexLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max index length in bytes
      Throws:
        `java.sql.SQLException`

    - #### getMaxProcedureNameLength

          public int getMaxProcedureNameLength()
                                        throws java.sql.SQLException

      What's the maximum length of a procedure name?
      Specified by:
        `getMaxProcedureNameLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max name length in bytes
      Throws:
        `java.sql.SQLException`

    - #### getMaxRowSize

          public int getMaxRowSize()
                            throws java.sql.SQLException

      What's the maximum length of a single row?
      Specified by:
        `getMaxRowSize` in interface `java.sql.DatabaseMetaData`
      Returns:
        max row size in bytes
      Throws:
        `java.sql.SQLException`

    - #### getMaxSchemaNameLength

          public int getMaxSchemaNameLength()
                                     throws java.sql.SQLException

      What's the maximum length allowed for a schema name?
      Specified by:
        `getMaxSchemaNameLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max name length in bytes
      Throws:
        `java.sql.SQLException`

    - #### getMaxStatementLength

          public int getMaxStatementLength()
                                    throws java.sql.SQLException

      What's the maximum length of a SQL statement?
      Specified by:
        `getMaxStatementLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max length in bytes
      Throws:
        `java.sql.SQLException`

    - #### getMaxStatements

          public int getMaxStatements()
                               throws java.sql.SQLException

      How many active statements can we have open at one time to this database?
      Specified by:
        `getMaxStatements` in interface `java.sql.DatabaseMetaData`
      Returns:
        the maximum
      Throws:
        `java.sql.SQLException`

    - #### getMaxTableNameLength

          public int getMaxTableNameLength()
                                    throws java.sql.SQLException

      What's the maximum length of a table name?
      Specified by:
        `getMaxTableNameLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max name length in bytes
      Throws:
        `java.sql.SQLException`

    - #### getMaxTablesInSelect

          public int getMaxTablesInSelect()
                                   throws java.sql.SQLException

      What's the maximum number of tables in a SELECT?
      Specified by:
        `getMaxTablesInSelect` in interface `java.sql.DatabaseMetaData`
      Returns:
        the maximum
      Throws:
        `java.sql.SQLException`

    - #### getMaxUserNameLength

          public int getMaxUserNameLength()
                                   throws java.sql.SQLException

      What's the maximum length of a user name?
      Specified by:
        `getMaxUserNameLength` in interface `java.sql.DatabaseMetaData`
      Returns:
        max name length in bytes
      Throws:
        `java.sql.SQLException`

    - #### getNumericFunctions

          public java.lang.String getNumericFunctions()
                                               throws java.sql.SQLException

      Get a comma separated list of math functions.
      Specified by:
        `getNumericFunctions` in interface `java.sql.DatabaseMetaData`
      Returns:
        the list
      Throws:
        `java.sql.SQLException`

    - #### getPrimaryKeys

          public java.sql.ResultSet getPrimaryKeys(java.lang.String catalog,
                                          java.lang.String schema,
                                          java.lang.String table)
                                            throws java.sql.SQLException

      Get a description of a table's primary key columns. They are ordered by COLUMN_NAME.

      Each column description has the following columns:

      1. TABLE_CAT String => table catalog (may be null)
      2. TABLE_SCHEM String => table schema (may be null)
      3. TABLE_NAME String => table name
      4. COLUMN_NAME String => column name
      5. KEY_SEQ short => sequence number within primary key
      6. PK_NAME String => primary key name (may be null)
      Specified by:
        `getPrimaryKeys` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schema` - a schema name pattern; "" retrieves those without a schema
        `table` - a table name
      Returns:
        ResultSet each row is a primary key column description
      Throws:
        `java.sql.SQLException`

    - #### getProcedureColumns

          public java.sql.ResultSet getProcedureColumns(java.lang.String catalog,
                                               java.lang.String schemaPattern,
                                               java.lang.String procedureNamePattern,
                                               java.lang.String columnNamePattern)
                                                 throws java.sql.SQLException

      Get a description of a catalog's stored procedure parameters and result columns.

      Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

      Each row in the ResultSet is a parameter description or column description with the following fields:

      1. PROCEDURE_CAT String => procedure catalog (may be null)
      2. PROCEDURE_SCHEM String => procedure schema (may be null)
      3. PROCEDURE_NAME String => procedure name
      4. COLUMN_NAME String => column/parameter name
      5. COLUMN_TYPE Short => kind of column/parameter:
         - procedureColumnUnknown - nobody knows
         - procedureColumnIn - IN parameter
         - procedureColumnInOut - INOUT parameter
         - procedureColumnOut - OUT parameter
         - procedureColumnReturn - procedure return value
         - procedureColumnResult - result column in ResultSet
      6. DATA_TYPE short => SQL type from java.sql.Types
      7. TYPE_NAME String => SQL type name
      8. PRECISION int => precision
      9. LENGTH int => length in bytes of data
      10. SCALE short => scale
      11. RADIX short => radix
      12. NULLABLE short => can it contain NULL?
          - procedureNoNulls - does not allow NULL values
          - procedureNullable - allows NULL values
          - procedureNullableUnknown - nullability unknown
      13. REMARKS String => comment describing parameter/column
      14. COLUMN_DEF String => default value for the column (may be null)
      15. SQL_DATA_TYPE int => reserved for future use
      16. SQL_DATETIME_SUB int => reserved for future use
      17. CHAR_OCTET_LENGTH int => the maximum length of binary and character based columns. For any other datatype the returned value is a NULL
      18. ORDINAL_POSITION int => the ordinal position, starting from 1. A value of 0 is returned if this row describes the procedure's return value.
      19. IS_NULLABLE String => ISO rules are used to determine the nullability for a column.
          - YES --- if the parameter can include NULLs
          - NO --- if the parameter cannot include NULLs
          - empty string --- if the nullability for the parameter is unknown
      20. SPECIFIC_NAME String => the name which uniquely identifies this procedure within its schema.

      Note: Some databases may not return the column descriptions for a procedure.

      Specified by:
        `getProcedureColumns` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schemaPattern` - a schema name pattern; "" retrieves those without a schema
        `procedureNamePattern` - a procedure name pattern
        `columnNamePattern` - a column name pattern
      Returns:
        ResultSet each row is a stored procedure parameter or column description
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `getSearchStringEscape()`

    - #### createProcedureColumnsFields

          protected Field[] createProcedureColumnsFields()

    - #### getProcedureOrFunctionColumns

          protected java.sql.ResultSet getProcedureOrFunctionColumns(Field[] fields,
                                                         java.lang.String catalog,
                                                         java.lang.String schemaPattern,
                                                         java.lang.String procedureOrFunctionNamePattern,
                                                         java.lang.String columnNamePattern,
                                                         boolean returnProcedures,
                                                         boolean returnFunctions)
                                                              throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### getProcedures

          public java.sql.ResultSet getProcedures(java.lang.String catalog,
                                         java.lang.String schemaPattern,
                                         java.lang.String procedureNamePattern)
                                           throws java.sql.SQLException

      Get a description of stored procedures available in a catalog.

      Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by PROCEDURE_SCHEM, and PROCEDURE_NAME.

      Each procedure description has the the following columns:

      1. PROCEDURE_CAT String => procedure catalog (may be null)
      2. PROCEDURE_SCHEM String => procedure schema (may be null)
      3. PROCEDURE_NAME String => procedure name
      4. reserved for future use
      5. reserved for future use
      6. reserved for future use
      7. REMARKS String => explanatory comment on the procedure
      8. PROCEDURE_TYPE short => kind of procedure:
         - procedureResultUnknown - May return a result
         - procedureNoResult - Does not return a result
         - procedureReturnsResult - Returns a result
      Specified by:
        `getProcedures` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schemaPattern` - a schema name pattern; "" retrieves those without a schema
        `procedureNamePattern` - a procedure name pattern
      Returns:
        ResultSet each row is a procedure description
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `getSearchStringEscape()`

    - #### createFieldMetadataForGetProcedures

          protected Field[] createFieldMetadataForGetProcedures()

    - #### getProceduresAndOrFunctions

          protected java.sql.ResultSet getProceduresAndOrFunctions(Field[] fields,
                                                       java.lang.String catalog,
                                                       java.lang.String schemaPattern,
                                                       java.lang.String procedureNamePattern,
                                                       boolean returnProcedures,
                                                       boolean returnFunctions)
                                                            throws java.sql.SQLException

      Parameters:
        `fields` -
        `catalog` -
        `schemaPattern` -
        `procedureNamePattern` -
        `returnProcedures` -
        `returnFunctions` -
      Throws:
        `java.sql.SQLException`

    - #### getProcedureTerm

          public java.lang.String getProcedureTerm()
                                            throws java.sql.SQLException

      What's the database vendor's preferred term for "procedure"?
      Specified by:
        `getProcedureTerm` in interface `java.sql.DatabaseMetaData`
      Returns:
        the vendor term
      Throws:
        `java.sql.SQLException` - if an error occurs (don't know why it would in this case...)

    - #### getResultSetHoldability

          public int getResultSetHoldability()
                                      throws java.sql.SQLException

      Specified by:
        `getResultSetHoldability` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getResultSetHoldability()`

    - #### getSchemas

          public java.sql.ResultSet getSchemas()
                                        throws java.sql.SQLException

      Get the schema names available in this database. The results are ordered by schema name.

      The schema column is:

      1. TABLE_SCHEM String => schema name
      Specified by:
        `getSchemas` in interface `java.sql.DatabaseMetaData`
      Returns:
        ResultSet each row has a single String column that is a schema name
      Throws:
        `java.sql.SQLException`

    - #### getSchemaTerm

          public java.lang.String getSchemaTerm()
                                         throws java.sql.SQLException

      What's the database vendor's preferred term for "schema"?
      Specified by:
        `getSchemaTerm` in interface `java.sql.DatabaseMetaData`
      Returns:
        the vendor term
      Throws:
        `java.sql.SQLException`

    - #### getSearchStringEscape

          public java.lang.String getSearchStringEscape()
                                                 throws java.sql.SQLException

      This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.

      The '_' character represents any single character.

      The '%' character represents any sequence of zero or more characters.

      Specified by:
        `getSearchStringEscape` in interface `java.sql.DatabaseMetaData`
      Returns:
        the string used to escape wildcard characters
      Throws:
        `java.sql.SQLException`

    - #### getSQLKeywords

          public java.lang.String getSQLKeywords()
                                          throws java.sql.SQLException

      Get a comma separated list of all a database's SQL keywords that are NOT also SQL92/SQL2003 keywords.
      Specified by:
        `getSQLKeywords` in interface `java.sql.DatabaseMetaData`
      Returns:
        the list
      Throws:
        `java.sql.SQLException`

    - #### getSQLStateType

          public int getSQLStateType()
                              throws java.sql.SQLException

      Specified by:
        `getSQLStateType` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getSQLStateType()`

    - #### getStringFunctions

          public java.lang.String getStringFunctions()
                                              throws java.sql.SQLException

      Get a comma separated list of string functions.
      Specified by:
        `getStringFunctions` in interface `java.sql.DatabaseMetaData`
      Returns:
        the list
      Throws:
        `java.sql.SQLException`

    - #### getSuperTables

          public java.sql.ResultSet getSuperTables(java.lang.String arg0,
                                          java.lang.String arg1,
                                          java.lang.String arg2)
                                            throws java.sql.SQLException

      Specified by:
        `getSuperTables` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getSuperTables(String, String, String)`

    - #### getSuperTypes

          public java.sql.ResultSet getSuperTypes(java.lang.String arg0,
                                         java.lang.String arg1,
                                         java.lang.String arg2)
                                           throws java.sql.SQLException

      Specified by:
        `getSuperTypes` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `getSuperTypes(String, String, String)`

    - #### getSystemFunctions

          public java.lang.String getSystemFunctions()
                                              throws java.sql.SQLException

      Get a comma separated list of system functions.
      Specified by:
        `getSystemFunctions` in interface `java.sql.DatabaseMetaData`
      Returns:
        the list
      Throws:
        `java.sql.SQLException`

    - #### getTableNameWithCase

          protected java.lang.String getTableNameWithCase(java.lang.String table)

    - #### getTablePrivileges

          public java.sql.ResultSet getTablePrivileges(java.lang.String catalog,
                                              java.lang.String schemaPattern,
                                              java.lang.String tableNamePattern)
                                                throws java.sql.SQLException

      Get a description of the access rights for each table available in a catalog.

      Only privileges matching the schema and table name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME, and PRIVILEGE.

      Each privilige description has the following columns:

      1. TABLE_CAT String => table catalog (may be null)
      2. TABLE_SCHEM String => table schema (may be null)
      3. TABLE_NAME String => table name
      4. COLUMN_NAME String => column name
      5. GRANTOR => grantor of access (may be null)
      6. GRANTEE String => grantee of access
      7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
      8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown
      Specified by:
        `getTablePrivileges` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schemaPattern` - a schema name pattern; "" retrieves those without a schema
        `tableNamePattern` - a table name pattern
      Returns:
        ResultSet each row is a table privilege description
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `getSearchStringEscape()`

    - #### getTables

          public java.sql.ResultSet getTables(java.lang.String catalog,
                                     java.lang.String schemaPattern,
                                     java.lang.String tableNamePattern,
                                     java.lang.String[] types)
                                       throws java.sql.SQLException

      Get a description of tables available in a catalog.

      Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

      Each table description has the following columns:

      1. TABLE_CAT String => table catalog (may be null)
      2. TABLE_SCHEM String => table schema (may be null)
      3. TABLE_NAME String => table name
      4. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
      5. REMARKS String => explanatory comment on the table

      Note: Some databases may not return information for all tables.

      Specified by:
        `getTables` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schemaPattern` - a schema name pattern; "" retrieves those without a schema
        `tableNamePattern` - a table name pattern
        `types` - a list of table types to include; null returns all types
      Returns:
        ResultSet each row is a table description
      Throws:
        `java.sql.SQLException`
      See Also:
        `getSearchStringEscape()`

    - #### createTablesFields

          protected Field[] createTablesFields()

    - #### getTableTypes

          public java.sql.ResultSet getTableTypes()
                                           throws java.sql.SQLException

      Get the table types available in this database. The results are ordered by table type.

      The table type is:

      1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
      Specified by:
        `getTableTypes` in interface `java.sql.DatabaseMetaData`
      Returns:
        ResultSet each row has a single String column that is a table type
      Throws:
        `java.sql.SQLException`

    - #### getTimeDateFunctions

          public java.lang.String getTimeDateFunctions()
                                                throws java.sql.SQLException

      Get a comma separated list of time and date functions.
      Specified by:
        `getTimeDateFunctions` in interface `java.sql.DatabaseMetaData`
      Returns:
        the list
      Throws:
        `java.sql.SQLException`

    - #### getTypeInfo

          public java.sql.ResultSet getTypeInfo()
                                         throws java.sql.SQLException

      Get a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

      Each type description has the following columns:

      1. TYPE_NAME String => Type name
      2. DATA_TYPE short => SQL data type from java.sql.Types
      3. PRECISION int => maximum precision
      4. LITERAL_PREFIX String => prefix used to quote a literal (may be null)
      5. LITERAL_SUFFIX String => suffix used to quote a literal (may be null)
      6. CREATE_PARAMS String => parameters used in creating the type (may be null)
      7. NULLABLE short => can you use NULL for this type?
         - typeNoNulls - does not allow NULL values
         - typeNullable - allows NULL values
         - typeNullableUnknown - nullability unknown
      8. CASE_SENSITIVE boolean=> is it case sensitive?
      9. SEARCHABLE short => can you use "WHERE" based on this type:
         - typePredNone - No support
         - typePredChar - Only supported with WHERE .. LIKE
         - typePredBasic - Supported except for WHERE .. LIKE
         - typeSearchable - Supported for all WHERE ..
      10. UNSIGNED_ATTRIBUTE boolean => is it unsigned?
      11. FIXED_PREC_SCALE boolean => can it be a money value?
      12. AUTO_INCREMENT boolean => can it be used for an auto-increment value?
      13. LOCAL_TYPE_NAME String => localized version of type name (may be null)
      14. MINIMUM_SCALE short => minimum scale supported
      15. MAXIMUM_SCALE short => maximum scale supported
      16. SQL_DATA_TYPE int => unused
      17. SQL_DATETIME_SUB int => unused
      18. NUM_PREC_RADIX int => usually 2 or 10
      Specified by:
        `getTypeInfo` in interface `java.sql.DatabaseMetaData`
      Returns:
        ResultSet each row is a SQL type description
      Throws:
        `java.sql.SQLException`

    - #### getUDTs

          public java.sql.ResultSet getUDTs(java.lang.String catalog,
                                   java.lang.String schemaPattern,
                                   java.lang.String typeNamePattern,
                                   int[] types)
                                     throws java.sql.SQLException

      JDBC 2.0 Get a description of the user-defined types defined in a particular schema. Schema specific UDTs may have type JAVA_OBJECT, STRUCT, or DISTINCT.

      Only types matching the catalog, schema, type name and type criteria are returned. They are ordered by DATA_TYPE, TYPE_SCHEM and TYPE_NAME. The type name parameter may be a fully qualified name. In this case, the catalog and schemaPattern parameters are ignored.

      Each type description has the following columns:

      1. TYPE_CAT String => the type's catalog (may be null)
      2. TYPE_SCHEM String => type's schema (may be null)
      3. TYPE_NAME String => type name
      4. CLASS_NAME String => Java class name
      5. DATA_TYPE String => type value defined in java.sql.Types. One of JAVA_OBJECT, STRUCT, or DISTINCT
      6. REMARKS String => explanatory comment on the type

      Note: If the driver does not support UDTs then an empty result set is returned.

      Specified by:
        `getUDTs` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
        `schemaPattern` - a schema name pattern; "" retrieves those without a schema
        `typeNamePattern` - a type name pattern; may be a fully qualified name
        `types` - a list of user-named types to include (JAVA_OBJECT, STRUCT, or DISTINCT); null returns all types
      Returns:
        ResultSet - each row is a type description
      Throws:
        `java.sql.SQLException` - if a database-access error occurs.

    - #### getURL

          public java.lang.String getURL()
                                  throws java.sql.SQLException

      What's the url for this database?
      Specified by:
        `getURL` in interface `java.sql.DatabaseMetaData`
      Returns:
        the url or null if it can't be generated
      Throws:
        `java.sql.SQLException`

    - #### getUserName

          public java.lang.String getUserName()
                                       throws java.sql.SQLException

      What's our user name as known to the database?
      Specified by:
        `getUserName` in interface `java.sql.DatabaseMetaData`
      Returns:
        our database user name
      Throws:
        `java.sql.SQLException`

    - #### getVersionColumns

          public java.sql.ResultSet getVersionColumns(java.lang.String catalog,
                                             java.lang.String schema,
                                             java.lang.String table)
                                               throws java.sql.SQLException

      Get a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

      Each column description has the following columns:

      1. SCOPE short => is not used
      2. COLUMN_NAME String => column name
      3. DATA_TYPE short => SQL data type from java.sql.Types
      4. TYPE_NAME String => Data source dependent type name
      5. COLUMN_SIZE int => precision
      6. BUFFER_LENGTH int => length of column value in bytes
      7. DECIMAL_DIGITS short => scale
      8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
         - versionColumnUnknown - may or may not be pseudo column
         - versionColumnNotPseudo - is NOT a pseudo column
         - versionColumnPseudo - is a pseudo column
      Specified by:
        `getVersionColumns` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; "" retrieves those without a catalog
        `schema` - a schema name; "" retrieves those without a schema
        `table` - a table name
      Returns:
        ResultSet each row is a column description
      Throws:
        `java.sql.SQLException`

    - #### insertsAreDetected

          public boolean insertsAreDetected(int type)
                                     throws java.sql.SQLException

      JDBC 2.0 Determine whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
      Specified by:
        `insertsAreDetected` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` - set type, i.e. ResultSet.TYPE_XXX
      Returns:
        true if changes are detected by the resultset type
      Throws:
        `java.sql.SQLException` - if a database-access error occurs.

    - #### isCatalogAtStart

          public boolean isCatalogAtStart()
                                   throws java.sql.SQLException

      Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)
      Specified by:
        `isCatalogAtStart` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if it appears at the start
      Throws:
        `java.sql.SQLException`

    - #### isReadOnly

          public boolean isReadOnly()
                             throws java.sql.SQLException

      Is the database in read-only mode?
      Specified by:
        `isReadOnly` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### locatorsUpdateCopy

          public boolean locatorsUpdateCopy()
                                     throws java.sql.SQLException

      Specified by:
        `locatorsUpdateCopy` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `locatorsUpdateCopy()`

    - #### nullPlusNonNullIsNull

          public boolean nullPlusNonNullIsNull()
                                        throws java.sql.SQLException

      Are concatenations between NULL and non-NULL values NULL? A JDBC compliant driver always returns true.
      Specified by:
        `nullPlusNonNullIsNull` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### nullsAreSortedAtEnd

          public boolean nullsAreSortedAtEnd()
                                      throws java.sql.SQLException

      Are NULL values sorted at the end regardless of sort order?
      Specified by:
        `nullsAreSortedAtEnd` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### nullsAreSortedAtStart

          public boolean nullsAreSortedAtStart()
                                        throws java.sql.SQLException

      Are NULL values sorted at the start regardless of sort order?
      Specified by:
        `nullsAreSortedAtStart` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### nullsAreSortedHigh

          public boolean nullsAreSortedHigh()
                                     throws java.sql.SQLException

      Are NULL values sorted high?
      Specified by:
        `nullsAreSortedHigh` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### nullsAreSortedLow

          public boolean nullsAreSortedLow()
                                    throws java.sql.SQLException

      Are NULL values sorted low?
      Specified by:
        `nullsAreSortedLow` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### othersDeletesAreVisible

          public boolean othersDeletesAreVisible(int type)
                                          throws java.sql.SQLException

      Specified by:
        `othersDeletesAreVisible` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` -
      Throws:
        `java.sql.SQLException`

    - #### othersInsertsAreVisible

          public boolean othersInsertsAreVisible(int type)
                                          throws java.sql.SQLException

      Specified by:
        `othersInsertsAreVisible` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` -
      Throws:
        `java.sql.SQLException`

    - #### othersUpdatesAreVisible

          public boolean othersUpdatesAreVisible(int type)
                                          throws java.sql.SQLException

      JDBC 2.0 Determine whether changes made by others are visible.
      Specified by:
        `othersUpdatesAreVisible` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` - set type, i.e. ResultSet.TYPE_XXX
      Returns:
        true if changes are visible for the result set type
      Throws:
        `java.sql.SQLException` - if a database-access error occurs.

    - #### ownDeletesAreVisible

          public boolean ownDeletesAreVisible(int type)
                                       throws java.sql.SQLException

      Specified by:
        `ownDeletesAreVisible` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` -
      Throws:
        `java.sql.SQLException`

    - #### ownInsertsAreVisible

          public boolean ownInsertsAreVisible(int type)
                                       throws java.sql.SQLException

      Specified by:
        `ownInsertsAreVisible` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` -
      Throws:
        `java.sql.SQLException`

    - #### ownUpdatesAreVisible

          public boolean ownUpdatesAreVisible(int type)
                                       throws java.sql.SQLException

      JDBC 2.0 Determine whether a result set's own changes visible.
      Specified by:
        `ownUpdatesAreVisible` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` - set type, i.e. ResultSet.TYPE_XXX
      Returns:
        true if changes are visible for the result set type
      Throws:
        `java.sql.SQLException` - if a database-access error occurs.

    - #### parseTableStatusIntoLocalAndReferencedColumns

          protected DatabaseMetaData.LocalAndReferencedColumns parseTableStatusIntoLocalAndReferencedColumns(java.lang.String keysComment)
                                                                                                      throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### s2b

          protected byte[] s2b(java.lang.String s)
                        throws java.sql.SQLException

      Converts the given string to bytes, using the connection's character encoding, or if not available, the JVM default encoding.
      Parameters:
        `s` -
      Throws:
        `java.sql.SQLException`

    - #### storesLowerCaseIdentifiers

          public boolean storesLowerCaseIdentifiers()
                                             throws java.sql.SQLException

      Does the database store mixed case unquoted SQL identifiers in lower case?
      Specified by:
        `storesLowerCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### storesLowerCaseQuotedIdentifiers

          public boolean storesLowerCaseQuotedIdentifiers()
                                                   throws java.sql.SQLException

      Does the database store mixed case quoted SQL identifiers in lower case? A JDBC compliant driver will always return false.
      Specified by:
        `storesLowerCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### storesMixedCaseIdentifiers

          public boolean storesMixedCaseIdentifiers()
                                             throws java.sql.SQLException

      Does the database store mixed case unquoted SQL identifiers in mixed case?
      Specified by:
        `storesMixedCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### storesMixedCaseQuotedIdentifiers

          public boolean storesMixedCaseQuotedIdentifiers()
                                                   throws java.sql.SQLException

      Does the database store mixed case quoted SQL identifiers in mixed case? A JDBC compliant driver will always return false.
      Specified by:
        `storesMixedCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### storesUpperCaseIdentifiers

          public boolean storesUpperCaseIdentifiers()
                                             throws java.sql.SQLException

      Does the database store mixed case unquoted SQL identifiers in upper case?
      Specified by:
        `storesUpperCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### storesUpperCaseQuotedIdentifiers

          public boolean storesUpperCaseQuotedIdentifiers()
                                                   throws java.sql.SQLException

      Does the database store mixed case quoted SQL identifiers in upper case? A JDBC compliant driver will always return true.
      Specified by:
        `storesUpperCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsAlterTableWithAddColumn

          public boolean supportsAlterTableWithAddColumn()
                                                  throws java.sql.SQLException

      Is "ALTER TABLE" with add column supported?
      Specified by:
        `supportsAlterTableWithAddColumn` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsAlterTableWithDropColumn

          public boolean supportsAlterTableWithDropColumn()
                                                   throws java.sql.SQLException

      Is "ALTER TABLE" with drop column supported?
      Specified by:
        `supportsAlterTableWithDropColumn` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsANSI92EntryLevelSQL

          public boolean supportsANSI92EntryLevelSQL()
                                              throws java.sql.SQLException

      Is the ANSI92 entry level SQL grammar supported? All JDBC compliant drivers must return true.
      Specified by:
        `supportsANSI92EntryLevelSQL` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsANSI92FullSQL

          public boolean supportsANSI92FullSQL()
                                        throws java.sql.SQLException

      Is the ANSI92 full SQL grammar supported?
      Specified by:
        `supportsANSI92FullSQL` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsANSI92IntermediateSQL

          public boolean supportsANSI92IntermediateSQL()
                                                throws java.sql.SQLException

      Is the ANSI92 intermediate SQL grammar supported?
      Specified by:
        `supportsANSI92IntermediateSQL` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsBatchUpdates

          public boolean supportsBatchUpdates()
                                       throws java.sql.SQLException

      JDBC 2.0 Return true if the driver supports batch updates, else return false.
      Specified by:
        `supportsBatchUpdates` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`

    - #### supportsCatalogsInDataManipulation

          public boolean supportsCatalogsInDataManipulation()
                                                     throws java.sql.SQLException

      Can a catalog name be used in a data manipulation statement?
      Specified by:
        `supportsCatalogsInDataManipulation` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsCatalogsInIndexDefinitions

          public boolean supportsCatalogsInIndexDefinitions()
                                                     throws java.sql.SQLException

      Can a catalog name be used in a index definition statement?
      Specified by:
        `supportsCatalogsInIndexDefinitions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsCatalogsInPrivilegeDefinitions

          public boolean supportsCatalogsInPrivilegeDefinitions()
                                                         throws java.sql.SQLException

      Can a catalog name be used in a privilege definition statement?
      Specified by:
        `supportsCatalogsInPrivilegeDefinitions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsCatalogsInProcedureCalls

          public boolean supportsCatalogsInProcedureCalls()
                                                   throws java.sql.SQLException

      Can a catalog name be used in a procedure call statement?
      Specified by:
        `supportsCatalogsInProcedureCalls` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsCatalogsInTableDefinitions

          public boolean supportsCatalogsInTableDefinitions()
                                                     throws java.sql.SQLException

      Can a catalog name be used in a table definition statement?
      Specified by:
        `supportsCatalogsInTableDefinitions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsColumnAliasing

          public boolean supportsColumnAliasing()
                                         throws java.sql.SQLException

      Is column aliasing supported?

      If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required. A JDBC compliant driver always returns true.

      Specified by:
        `supportsColumnAliasing` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsConvert

          public boolean supportsConvert()
                                  throws java.sql.SQLException

      Is the CONVERT function between SQL types supported?
      Specified by:
        `supportsConvert` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsConvert

          public boolean supportsConvert(int fromType,
                                int toType)
                                  throws java.sql.SQLException

      Is CONVERT between the given SQL types supported?
      Specified by:
        `supportsConvert` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `fromType` - the type to convert from
        `toType` - the type to convert to
      Returns:
        true if so
      Throws:
        `java.sql.SQLException` - if an error occurs
      See Also:
        `Types`

    - #### supportsCoreSQLGrammar

          public boolean supportsCoreSQLGrammar()
                                         throws java.sql.SQLException

      Is the ODBC Core SQL grammar supported?
      Specified by:
        `supportsCoreSQLGrammar` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsCorrelatedSubqueries

          public boolean supportsCorrelatedSubqueries()
                                               throws java.sql.SQLException

      Are correlated subqueries supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsCorrelatedSubqueries` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsDataDefinitionAndDataManipulationTransactions

          public boolean supportsDataDefinitionAndDataManipulationTransactions()
                                                                        throws java.sql.SQLException

      Are both data definition and data manipulation statements within a transaction supported?
      Specified by:
        `supportsDataDefinitionAndDataManipulationTransactions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsDataManipulationTransactionsOnly

          public boolean supportsDataManipulationTransactionsOnly()
                                                           throws java.sql.SQLException

      Are only data manipulation statements within a transaction supported?
      Specified by:
        `supportsDataManipulationTransactionsOnly` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsDifferentTableCorrelationNames

          public boolean supportsDifferentTableCorrelationNames()
                                                         throws java.sql.SQLException

      If table correlation names are supported, are they restricted to be different from the names of the tables? A JDBC compliant driver always returns true.
      Specified by:
        `supportsDifferentTableCorrelationNames` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsExpressionsInOrderBy

          public boolean supportsExpressionsInOrderBy()
                                               throws java.sql.SQLException

      Are expressions in "ORDER BY" lists supported?
      Specified by:
        `supportsExpressionsInOrderBy` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsExtendedSQLGrammar

          public boolean supportsExtendedSQLGrammar()
                                             throws java.sql.SQLException

      Is the ODBC Extended SQL grammar supported?
      Specified by:
        `supportsExtendedSQLGrammar` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsFullOuterJoins

          public boolean supportsFullOuterJoins()
                                         throws java.sql.SQLException

      Are full nested outer joins supported?
      Specified by:
        `supportsFullOuterJoins` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsGetGeneratedKeys

          public boolean supportsGetGeneratedKeys()

      JDBC 3.0
      Specified by:
        `supportsGetGeneratedKeys` in interface `java.sql.DatabaseMetaData`

    - #### supportsGroupBy

          public boolean supportsGroupBy()
                                  throws java.sql.SQLException

      Is some form of "GROUP BY" clause supported?
      Specified by:
        `supportsGroupBy` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsGroupByBeyondSelect

          public boolean supportsGroupByBeyondSelect()
                                              throws java.sql.SQLException

      Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
      Specified by:
        `supportsGroupByBeyondSelect` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsGroupByUnrelated

          public boolean supportsGroupByUnrelated()
                                           throws java.sql.SQLException

      Can a "GROUP BY" clause use columns not in the SELECT?
      Specified by:
        `supportsGroupByUnrelated` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsIntegrityEnhancementFacility

          public boolean supportsIntegrityEnhancementFacility()
                                                       throws java.sql.SQLException

      Is the SQL Integrity Enhancement Facility supported?
      Specified by:
        `supportsIntegrityEnhancementFacility` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsLikeEscapeClause

          public boolean supportsLikeEscapeClause()
                                           throws java.sql.SQLException

      Is the escape character in "LIKE" clauses supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsLikeEscapeClause` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsLimitedOuterJoins

          public boolean supportsLimitedOuterJoins()
                                            throws java.sql.SQLException

      Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)
      Specified by:
        `supportsLimitedOuterJoins` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsMinimumSQLGrammar

          public boolean supportsMinimumSQLGrammar()
                                            throws java.sql.SQLException

      Is the ODBC Minimum SQL grammar supported? All JDBC compliant drivers must return true.
      Specified by:
        `supportsMinimumSQLGrammar` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsMixedCaseIdentifiers

          public boolean supportsMixedCaseIdentifiers()
                                               throws java.sql.SQLException

      Does the database support mixed case unquoted SQL identifiers?
      Specified by:
        `supportsMixedCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsMixedCaseQuotedIdentifiers

          public boolean supportsMixedCaseQuotedIdentifiers()
                                                     throws java.sql.SQLException

      Does the database support mixed case quoted SQL identifiers? A JDBC compliant driver will always return true.
      Specified by:
        `supportsMixedCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsMultipleOpenResults

          public boolean supportsMultipleOpenResults()
                                              throws java.sql.SQLException

      Specified by:
        `supportsMultipleOpenResults` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `supportsMultipleOpenResults()`

    - #### supportsMultipleResultSets

          public boolean supportsMultipleResultSets()
                                             throws java.sql.SQLException

      Are multiple ResultSets from a single execute supported?
      Specified by:
        `supportsMultipleResultSets` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsMultipleTransactions

          public boolean supportsMultipleTransactions()
                                               throws java.sql.SQLException

      Can we have multiple transactions open at once (on different connections)?
      Specified by:
        `supportsMultipleTransactions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsNamedParameters

          public boolean supportsNamedParameters()
                                          throws java.sql.SQLException

      Specified by:
        `supportsNamedParameters` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `supportsNamedParameters()`

    - #### supportsNonNullableColumns

          public boolean supportsNonNullableColumns()
                                             throws java.sql.SQLException

      Can columns be defined as non-nullable? A JDBC compliant driver always returns true.
      Specified by:
        `supportsNonNullableColumns` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsOpenCursorsAcrossCommit

          public boolean supportsOpenCursorsAcrossCommit()
                                                  throws java.sql.SQLException

      Can cursors remain open across commits?
      Specified by:
        `supportsOpenCursorsAcrossCommit` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `Connection#disableAutoClose`

    - #### supportsOpenCursorsAcrossRollback

          public boolean supportsOpenCursorsAcrossRollback()
                                                    throws java.sql.SQLException

      Can cursors remain open across rollbacks?
      Specified by:
        `supportsOpenCursorsAcrossRollback` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException` - if an error occurs
      See Also:
        `Connection#disableAutoClose`

    - #### supportsOpenStatementsAcrossCommit

          public boolean supportsOpenStatementsAcrossCommit()
                                                     throws java.sql.SQLException

      Can statements remain open across commits?
      Specified by:
        `supportsOpenStatementsAcrossCommit` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException` - if an error occurs
      See Also:
        `Connection#disableAutoClose`

    - #### supportsOpenStatementsAcrossRollback

          public boolean supportsOpenStatementsAcrossRollback()
                                                       throws java.sql.SQLException

      Can statements remain open across rollbacks?
      Specified by:
        `supportsOpenStatementsAcrossRollback` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException` - if an error occurs
      See Also:
        `Connection#disableAutoClose`

    - #### supportsOrderByUnrelated

          public boolean supportsOrderByUnrelated()
                                           throws java.sql.SQLException

      Can an "ORDER BY" clause use columns not in the SELECT?
      Specified by:
        `supportsOrderByUnrelated` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsOuterJoins

          public boolean supportsOuterJoins()
                                     throws java.sql.SQLException

      Is some form of outer join supported?
      Specified by:
        `supportsOuterJoins` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsPositionedDelete

          public boolean supportsPositionedDelete()
                                           throws java.sql.SQLException

      Is positioned DELETE supported?
      Specified by:
        `supportsPositionedDelete` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsPositionedUpdate

          public boolean supportsPositionedUpdate()
                                           throws java.sql.SQLException

      Is positioned UPDATE supported?
      Specified by:
        `supportsPositionedUpdate` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsResultSetConcurrency

          public boolean supportsResultSetConcurrency(int type,
                                             int concurrency)
                                               throws java.sql.SQLException

      JDBC 2.0 Does the database support the concurrency type in combination with the given result set type?
      Specified by:
        `supportsResultSetConcurrency` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` - defined in java.sql.ResultSet
        `concurrency` - type defined in java.sql.ResultSet
      Returns:
        true if so
      Throws:
        `java.sql.SQLException` - if a database-access error occurs.
      See Also:
        `Connection`

    - #### supportsResultSetHoldability

          public boolean supportsResultSetHoldability(int holdability)
                                               throws java.sql.SQLException

      Specified by:
        `supportsResultSetHoldability` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `supportsResultSetHoldability(int)`

    - #### supportsResultSetType

          public boolean supportsResultSetType(int type)
                                        throws java.sql.SQLException

      JDBC 2.0 Does the database support the given result set type?
      Specified by:
        `supportsResultSetType` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` - defined in java.sql.ResultSet
      Returns:
        true if so
      Throws:
        `java.sql.SQLException` - if a database-access error occurs.
      See Also:
        `Connection`

    - #### supportsSavepoints

          public boolean supportsSavepoints()
                                     throws java.sql.SQLException

      Specified by:
        `supportsSavepoints` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `supportsSavepoints()`

    - #### supportsSchemasInDataManipulation

          public boolean supportsSchemasInDataManipulation()
                                                    throws java.sql.SQLException

      Can a schema name be used in a data manipulation statement?
      Specified by:
        `supportsSchemasInDataManipulation` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSchemasInIndexDefinitions

          public boolean supportsSchemasInIndexDefinitions()
                                                    throws java.sql.SQLException

      Can a schema name be used in an index definition statement?
      Specified by:
        `supportsSchemasInIndexDefinitions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSchemasInPrivilegeDefinitions

          public boolean supportsSchemasInPrivilegeDefinitions()
                                                        throws java.sql.SQLException

      Can a schema name be used in a privilege definition statement?
      Specified by:
        `supportsSchemasInPrivilegeDefinitions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSchemasInProcedureCalls

          public boolean supportsSchemasInProcedureCalls()
                                                  throws java.sql.SQLException

      Can a schema name be used in a procedure call statement?
      Specified by:
        `supportsSchemasInProcedureCalls` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSchemasInTableDefinitions

          public boolean supportsSchemasInTableDefinitions()
                                                    throws java.sql.SQLException

      Can a schema name be used in a table definition statement?
      Specified by:
        `supportsSchemasInTableDefinitions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSelectForUpdate

          public boolean supportsSelectForUpdate()
                                          throws java.sql.SQLException

      Is SELECT for UPDATE supported?
      Specified by:
        `supportsSelectForUpdate` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsStatementPooling

          public boolean supportsStatementPooling()
                                           throws java.sql.SQLException

      Specified by:
        `supportsStatementPooling` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      See Also:
        `supportsStatementPooling()`

    - #### supportsStoredProcedures

          public boolean supportsStoredProcedures()
                                           throws java.sql.SQLException

      Are stored procedure calls using the stored procedure escape syntax supported?
      Specified by:
        `supportsStoredProcedures` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSubqueriesInComparisons

          public boolean supportsSubqueriesInComparisons()
                                                  throws java.sql.SQLException

      Are subqueries in comparison expressions supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsSubqueriesInComparisons` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSubqueriesInExists

          public boolean supportsSubqueriesInExists()
                                             throws java.sql.SQLException

      Are subqueries in exists expressions supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsSubqueriesInExists` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSubqueriesInIns

          public boolean supportsSubqueriesInIns()
                                          throws java.sql.SQLException

      Are subqueries in "in" statements supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsSubqueriesInIns` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsSubqueriesInQuantifieds

          public boolean supportsSubqueriesInQuantifieds()
                                                  throws java.sql.SQLException

      Are subqueries in quantified expressions supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsSubqueriesInQuantifieds` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsTableCorrelationNames

          public boolean supportsTableCorrelationNames()
                                                throws java.sql.SQLException

      Are table correlation names supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsTableCorrelationNames` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsTransactionIsolationLevel

          public boolean supportsTransactionIsolationLevel(int level)
                                                    throws java.sql.SQLException

      Does the database support the given transaction isolation level?
      Specified by:
        `supportsTransactionIsolationLevel` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `level` - the values are defined in java.sql.Connection
      Returns:
        true if so
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `Connection`

    - #### supportsTransactions

          public boolean supportsTransactions()
                                       throws java.sql.SQLException

      Are transactions supported? If not, commit is a noop and the isolation level is TRANSACTION_NONE.
      Specified by:
        `supportsTransactions` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if transactions are supported
      Throws:
        `java.sql.SQLException`

    - #### supportsUnion

          public boolean supportsUnion()
                                throws java.sql.SQLException

      Is SQL UNION supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsUnion` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### supportsUnionAll

          public boolean supportsUnionAll()
                                   throws java.sql.SQLException

      Is SQL UNION ALL supported? A JDBC compliant driver always returns true.
      Specified by:
        `supportsUnionAll` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### updatesAreDetected

          public boolean updatesAreDetected(int type)
                                     throws java.sql.SQLException

      JDBC 2.0 Determine whether or not a visible row update can be detected by calling ResultSet.rowUpdated().
      Specified by:
        `updatesAreDetected` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `type` - set type, i.e. ResultSet.TYPE_XXX
      Returns:
        true if changes are detected by the resultset type
      Throws:
        `java.sql.SQLException` - if a database-access error occurs.

    - #### usesLocalFilePerTable

          public boolean usesLocalFilePerTable()
                                        throws java.sql.SQLException

      Does the database use a file for each table?
      Specified by:
        `usesLocalFilePerTable` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if the database uses a local file for each table
      Throws:
        `java.sql.SQLException`

    - #### usesLocalFiles

          public boolean usesLocalFiles()
                                 throws java.sql.SQLException

      Does the database store tables in a local file?
      Specified by:
        `usesLocalFiles` in interface `java.sql.DatabaseMetaData`
      Returns:
        true if so
      Throws:
        `java.sql.SQLException`

    - #### getClientInfoProperties

          public java.sql.ResultSet getClientInfoProperties()
                                                     throws java.sql.SQLException

      Retrieves a list of the client info properties that the driver supports. The result set contains the following columns

      1. NAME String=> The name of the client info property
      2. MAX_LEN int=> The maximum length of the value for the property
      3. DEFAULT_VALUE String=> The default value of the property
      4. DESCRIPTION String=> A description of the property. This will typically contain information as to where this property is stored in the database.

      The `ResultSet` is sorted by the NAME column

      Specified by:
        `getClientInfoProperties` in interface `java.sql.DatabaseMetaData`
      Returns:
        A `ResultSet` object; each row is a supported client info property

      Throws:
        `java.sql.SQLException` - if a database access error occurs

      Since:
        1.6

    - #### getFunctionColumns

          public java.sql.ResultSet getFunctionColumns(java.lang.String catalog,
                                              java.lang.String schemaPattern,
                                              java.lang.String functionNamePattern,
                                              java.lang.String columnNamePattern)
                                                throws java.sql.SQLException

      Retrieves a description of the given catalog's system or user function parameters and return type.
      Specified by:
        `getFunctionColumns` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`
      Since:
        1.6
      See Also:
        `DatabaseMetaData.getFunctionColumns(String, String, String, String)`

    - #### createFunctionColumnsFields

          protected Field[] createFunctionColumnsFields()

    - #### getFunctions

          public java.sql.ResultSet getFunctions(java.lang.String catalog,
                                        java.lang.String schemaPattern,
                                        java.lang.String functionNamePattern)
                                          throws java.sql.SQLException

      Retrieves a description of the system and user functions available in the given catalog.

      Only system and user function descriptions matching the schema and function name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`.

      Each function description has the the following columns:

      1. FUNCTION_CAT String => function catalog (may be `null`)
      2. FUNCTION_SCHEM String => function schema (may be `null`)
      3. FUNCTION_NAME String => function name. This is the name used to invoke the function
      4. REMARKS String => explanatory comment on the function
      5. FUNCTION_TYPE short => kind of function:
         - functionResultUnknown - Cannot determine if a return value or table will be returned
         - functionNoTable- Does not return a table
         - functionReturnsTable - Returns a table
      6. SPECIFIC_NAME String => the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

      A user may not have permission to execute any of the functions that are returned by `getFunctions`

      Specified by:
        `getFunctions` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
        `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
        `functionNamePattern` - a function name pattern; must match the function name as it is stored in the database
      Returns:
        `ResultSet` - each row is a function description
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      Since:
        1.6
      See Also:
        `getSearchStringEscape()`

    - #### providesQueryObjectGenerator

          public boolean providesQueryObjectGenerator()
                                               throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### getSchemas

          public java.sql.ResultSet getSchemas(java.lang.String catalog,
                                      java.lang.String schemaPattern)
                                        throws java.sql.SQLException

      Specified by:
        `getSchemas` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` -
        `schemaPattern` -
      Throws:
        `java.sql.SQLException`

    - #### supportsStoredFunctionsUsingCallSyntax

          public boolean supportsStoredFunctionsUsingCallSyntax()
                                                         throws java.sql.SQLException

      Specified by:
        `supportsStoredFunctionsUsingCallSyntax` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`

    - #### prepareMetaDataSafeStatement

          protected java.sql.PreparedStatement prepareMetaDataSafeStatement(java.lang.String sql)
                                                                     throws java.sql.SQLException

      Get a prepared statement to query information_schema tables.
      Returns:
        PreparedStatement
      Throws:
        `java.sql.SQLException`

    - #### getPseudoColumns

          public java.sql.ResultSet getPseudoColumns(java.lang.String catalog,
                                            java.lang.String schemaPattern,
                                            java.lang.String tableNamePattern,
                                            java.lang.String columnNamePattern)
                                              throws java.sql.SQLException

      JDBC-4.1
      Specified by:
        `getPseudoColumns` in interface `java.sql.DatabaseMetaData`
      Parameters:
        `catalog` -
        `schemaPattern` -
        `tableNamePattern` -
        `columnNamePattern` -
      Throws:
        `java.sql.SQLException`

    - #### generatedKeyAlwaysReturned

          public boolean generatedKeyAlwaysReturned()
                                             throws java.sql.SQLException

      Specified by:
        `generatedKeyAlwaysReturned` in interface `java.sql.DatabaseMetaData`
      Throws:
        `java.sql.SQLException`